package com.googelcode.jpractices;

import java.io.Serializable;

import org.apache.commons.collections.Predicate;

/**
 * Copyright 2009 @ jPractices v 1.0
 * @SVN URL : http://jpractices.googlecode.com
 * @author Ganesh Gowtham
 * @Homepage : http://ganesh.gowtham.googlepages.com
 * @description This Predicate is responsible in selecting the salary greater than iValue
 */

public class SalaryHighPredicate implements Predicate, Serializable {

	/** Serial version UID */
	private static final long serialVersionUID = 5633766978029907089L;

	/** The value to compare to */
	private final int iValue;

	public SalaryHighPredicate(int salary) {
		super();
		iValue = salary;
	}

	/**
	 * returns true when the salary is >= iValue
	 */
	public boolean evaluate(Object object) {
		if (object instanceof Integer) {
			//System.err.println("oops");
			int value = Integer.parseInt(object.toString());
			return iValue <= value ? true : false;

		} else {
			// worst case wont happend :-)
			System.err.println("pls check whether passed attribute type");
			return false;
		}
	}

}
